# Notebook initialization

stick notebooks are [git repositories](https://git-scm.com/book/en/v2/Getting-Started-What-is-Git%3F) containing [Markdown](https://www.markdownguide.org/) formatted text files.

Note that while stick uses git, it is not required to have git installed.

Initialize one or more notebooks, specifying where the repository should be created.

If you would like to use an existing git repository, you may skip this step.

```
stick init /home/stick/notes/johnsnotes
```

# Configuring stick.yml

stick is configured via ~/.config/stick/stick.yml (or elsewhere when specified with the --config flag)

## salt

Used when hashing data (set to a random string)

## serve

Serve notebooks on this address (host:port)

## authors

List of authors, specified by email and name

## notebooks

List of notebooks, specified by label.  Options include:

### repo

Path to git repository

### serve

List of authors (specified by email) and their access level, which is one of the following:

- read
- write

Including an author named "public" will share the notebook publicly.

# Example stick.yml

```yaml
# Used when hashing data (set to a random string)
salt: xXxsh3cr3txXx

# Serve notes on localhost only
# Set to :9991 to serve on all interfaces (not recommended, use a reverse proxy instead)
serve: localhost:9991

# Authors are defined by email and name (used when committing)
authors:
  john@hotmail.com: John Doe
  jane@aol.com: Jane Doe

# Notebooks can be shared between authors with varying access levels
# When an access level isn't specified, read-only is assumed
# John's notebook allows read/write access to himself and read-only access to Jane
notebooks:
  John's notes:
    repo: /home/stick/notes/johnsnotes
    serve:
      - john@hotmail.com: write
      - jane@aol.com

  Jane's notes:
    repo: /home/stick/notes/janesnotes
    serve:
      - jane@aol.com: write
      - john@hotmail.com

  Shared notes:
    repo: /home/stick/notes/shared
    serve:
      - john@hotmail.com: write
      - jane@aol.com: write

  Public notes:
    repo: /home/stick/notes/public
    serve:
      - john@hotmail.com: write
      - jane@aol.com: write
      - public
```
